----------------------------------------------------------------------------------
-- Company: CSIRO CASS 
-- Engineer: David Humphrey
-- 
-- Create Date: 14.11.2018 11:27:29
-- Module Name: PSSFBTop - Behavioral
-- Description: 
--  Filterbank with 12 FIR taps, 64 point FFT, critically sampled.
--  Designed for the low.CBF PSS beamformer. Output is the central 54 frequency channels.
--  Processes 16 parallel signals (8 dual-pol stations),
--  each with 8 bit complex data (8 bit real + 8 bit imaginary).
--  
-- Processing rate
--  Assumptions
--    - 66 clocks per input packet (of 64 samples)
--    - 779 x (64-sample packets) per corner turn frame
--    - 24 * 2048 * 1080ns per corner turn frame = 53.08416 ms
--  So:
--    - 300 MHz clock = 15,925,248 clocks per corner turn frame
--      =  15925248/(779*66) = 309 virtual channels processed 
--      but 4 virtual channels in parallel, so up to 1239 virtual channels
--    - 250 MHz clock minimum
--
-- Supporting Code:
--  The Matlab model should be in the directory ../matlab_model
--  Key files:
--   * ../matlab_model/run_PSSFB.m 
--       Generates input files for the simulation, runs the matlab model and compares with simulation output.
--   * ../matlab_model/get_rom_coefficients.m
--       Generates ROM module used in the firmware, "PSSFIRTaps.vhd". 
--
--  Supporting VHDL 
--   * PSSFBtesttop.vhd 
--      Top level module that can be used to build this in a standalone version.
--   * PSSFB_tb.vhd
--      testbench, reads input data generated by the matlab code, and generates output data in text files for analysis by the matlab code. 
--
-- Structure:
--
--  File Structure
--  --------------
--  Outline of the structure shown below.
--
--    PSSFBTop.vhd : This file, 16 complex inputs, 12 FIR filter taps, 64 point FFT, critically sampled
--        |
--        +-- PSSFBmem.vhd   : Input memory for the filterbank, 12 blocks of memory chained together, see "step 1. Filterbank memory" below.
--        +-- fb_DSP.vhd     : 12 TAP FIR filter, see "2. FIR filter" below.
--        +-- PSSFFTwrapper.vhd : 64 point FFT. see "3. 1280 point FFT" below.
--                |
--                +-- fft64_16bit.xci : standard Xilinx 64 point FFT
--
--  Resource Use
--  ------------
--  Post place and route resource usage (U55c)
--   LUTs = 19166
--   DSPs = 512
--   Registers = 37268
--   BRAMs (36K) = 45
--   
--  -----------------------------------------------------------------------------------------------
--  Description
--  -----------
--
-- 1. Filterbank Memory
--   The filterbank memory consists of 11 blocks of memory chained together.
--   The read data from each memory is used both by the FIR filter and to write to the next memory in the chain.
--   The read and write addresses are staggered by one clock for each memory, implemented as a 12 sample delay line on
--   the address. This makes the timing easy to meet for the  memory address signals (which would otherwise be high-fanout signals)
--   and also enables use of the adders in the DSPs for the FIR filter. 
--     - 4 stations processed in parallel (4 stations x 2 pol = 8 inputs)
--     - The input memories are :
--       12 memories         x 64 deep              x 128 bits wide
--       (1 per filter tap) (64 words per group)   (4 stations x 2 pol x (1+1 complex) x 8 bits)
--
-- 2. FIR filter
--   The FIR filter uses 12 DSPs for each of the 16 simultaneous samples (4 stations * 2 pol * 2 (re+im)) that are read from the memory.
--   So the FIR filter uses (12 DSPS) * (8 simultaneous samples) * (2 (re+im)) = 192 DSPs.
--   The filter is implemented entirely in DSPs. The PCOUT port on the DSP is used to send the result of the multiplication
--   to the next DSP in the chain, where it is added using the adder in the DSP. This scheme requires that the inputs to the
--   12 DSPs are staggered to account for the pipeline stage on the PCOUT port. The staggering is done by controlling the address
--   to the memories as described above.
--
-- 3. 64 point FFT
--   Standard Xilinx FFT. Some messy logic at the front to account for the delay inserted by the "real-time" mode.
-- 
-- 4. Reorder memory
--   Data out of the FFT is in bit reversed order. It is stored in a double buffer in order from low to high frequencies,
--   then read out as 54 fine channels.
----------------------------------------------------------------------------------
library IEEE, common_lib, filterbank_lib, DSP_top_lib;
use IEEE.STD_LOGIC_1164.ALL;
use common_lib.common_pkg.all;
use IEEE.NUMERIC_STD.ALL;
Library xpm;
use xpm.vcomponents.all;
use DSP_top_lib.DSP_top_pkg.all;

entity PSSFBTop_4 is
    port(
        -- clock, minimum 250 MHz to process 1024 virtual channels 
        clk     : in std_logic;
        rst     : in std_logic;
        -- Data input, common valid signal, expects packets of 64 samples. Requires at least 2 clocks idle time between packets.
        i_data  : in std_logic_vector(127 downto 0); -- 8 Inputs, each complex data, 8 bit real (7:0), 8 bit imaginary (15:8).
        i_vc    : in std_logic_vector(15 downto 0);  -- First virtual channel
        i_valid : in std_logic;
        -- Data out; bursts of 54 clocks for each channel.
        o_data  : out t_FB_output_payload_a(3 downto 0); -- 4 virtual channels output
        o_valid : out std_logic
    );
end PSSFBTop_4;

architecture Behavioral of PSSFBTop_4 is
    
    signal FBmemRdData : t_slv_128_arr(11 downto 0);
    signal FBmemFIRTaps : t_slv_18_arr(11 downto 0);
    
    -- The first index in fbtype is for the number of filters = 16 (4 stations * 2 polarisations * 2[real+imaginary]).
    -- The second index is for the number of FIR taps.
    type fbtype is array(15 downto 0) of t_slv_8_arr(11 downto 0); 
    signal FBRdData : fbtype;
    signal FIRDout : t_slv_16_arr(15 downto 0);
    signal fftIndex : t_slv_6_arr(7 downto 0);
    
    signal fftRealOut : t_slv_16_arr(7 downto 0);
    signal fftImagOut : t_slv_16_arr(7 downto 0);
    signal fftvalidOut : std_logic_vector(7 downto 0) := x"00";
    
    signal startAdv : std_logic_vector(31 downto 0);
    signal validDel1, validDel2 : std_logic := '0';
    signal startFFT : std_logic := '0';
    
    signal reorderDout : std_logic_vector(255 downto 0);
    signal reorderWE : std_logic_vector(0 downto 0);
    signal reorderWrAddr : std_logic_vector(5 downto 0);
    signal reorderWrAddrFull : std_logic_vector(6 downto 0);
    signal reorderRdAddr : std_logic_vector(5 downto 0);
    signal reorderRdAddrFull : std_logic_vector(6 downto 0);
    signal bufSelectWr, bufSelectRd : std_logic := '0';
    signal reorderDin : std_logic_vector(255 downto 0);
    signal rdRunning : std_logic := '0';
    signal rdRunningDel2, rdRunningDel1 : std_logic := '0';
    signal validOutDel1 : std_logic := '0';
    signal bufSelectRdDel1, bufSelectRdDel2 : std_logic := '0';
    
begin
    
    ------------------------------------------------------------------------------------
    -- 1. Input Memory
    -- ---------------
    
    cmem : entity filterbank_lib.PSSFBMem_4
    generic map (TAPS => 12)  -- Note only partially parameterized; modification needed to support anything other than 12.
    port map (
        clk         => clk,
        -- Write data for the start of the chain
        i_wrData    => i_data,     -- in(127:0);
        i_wrEn      => i_valid,    -- in std_logic; should be a burst of 64 clocks.
        -- Read data, comes out 2 clocks after the first write.
        o_rd_data   => FBmemRdData,   -- out t_slv_128_arr(TAPS-1 downto 0); -- 128 bits wide, 12 taps simultaneously; First sample is wr_data_i delayed by 1 clock. 
        o_coef      => FBmemFIRTaps   -- out t_slv_18_arr(TAPS-1 downto 0); -- 18 bits per filter tap.
    );
    
    -------------------------------------------------------------------------------------
    -- 2. FIR filter
    -- -------------
    -- 12 instances, 6 channels * (real + imaginary). Same filter taps used for all.
    -- PISA low.CBF processes simultaneously 2 (real+imaginary) * 3 (stations) * 2 (polarisations) = 12
    -- 
    
    CsampleGen : for j in 0 to 15 generate  -- 16 filters
        coefGen : for k in 0 to 11 generate  -- 12 taps
            FBRdData(j)(k) <= FBmemRdData(k)((j*8 + 7) downto (j*8));
        end generate;
    end generate;
    
    sampleGen : for j in 0 to 15 generate
            
        FIR : entity filterbank_lib.fb_DSP
        generic map (
            TAPS => 12)  -- The module instantiates this number of DSPs
        port map (
            clk    => clk,
            data_i => FBRdData(j),  -- in array8bit_type(11 downto 0);
            coef_i => FBmemFIRTaps, -- in array18bit_type(11 downto 0);
            data_o => FIRDout(j)    -- out(15:0)
        );
    
    end generate;
    
    -------------------------------------------------------------------------------------
    -- 3. FFT
    -- -----------------
    -- 16 x 64 point FFTs.
    
    process(clk)
    begin
        if rising_edge(clk) then
            validDel1 <= i_valid;
            validDel2 <= validDel1;
            if validDel1 = '1' and validDel2 = '0' then
                startAdv(0) <= '1';
            else
                startAdv(0) <= '0';
            end if;
            
            startAdv(31 downto 1) <= startAdv(30 downto 0);
            -- Delay accounts for the delay through the FIR filter,
            -- plus a few clocks delay in the memory
            startFFT <= startAdv(14); 
            
        end if;
    end process;
    
    
    fftgen : for j in 0 to 7 generate
        
        fft64 : entity filterbank_lib.PSSFFTwrapper
        port map (
            clk  => clk,
            -- Input
            real_i  => FIRDout(j*2),     -- in(15:0); 16 bit real data
            imag_i  => FIRDout(j*2 + 1), -- in(15:0); 16 bit imaginary data
            start_i => startFFT,         -- in std_logic; pulse high; one clock in advance of the data 
            -- Output
            real_o  => fftRealOut(j), -- out(15:0);
            imag_o  => fftImagOut(j), -- out(15:0);
            index_o => fftIndex(j),   -- out(5:0);
            valid_o => fftvalidOut(j) -- out std_logic
        );
    
    end generate;
    
    -------------------------------------------------------------------------------------
    -- 4. Reorder the output from bit-reversed to the central 54 channels, low to high frequency.
    -- Uses a simple dual port BRAM double buffer.
      
    process(clk)
    begin
        if rising_edge(clk) then
        
            if (fftvalidOut(0) = '1' and (signed(fftIndex(0)) > -28) and (signed(fftIndex(0)) < 27)) then
                reorderWE(0) <= '1';
            else
                reorderWE(0) <= '0';
            end if;
            reorderWrAddr <= std_logic_vector(signed(fftIndex(0)) + 27);
            reorderDin(63 downto 0)    <= fftImagOut(1) & fftRealOut(1) & fftImagOut(0) & fftRealOut(0);
            reorderDin(127 downto 64)  <= fftImagOut(3) & fftRealOut(3) & fftImagOut(2) & fftRealOut(2);
            reorderDin(191 downto 128) <= fftImagOut(5) & fftRealOut(5) & fftImagOut(4) & fftRealOut(4);
            reorderDin(255 downto 192) <= fftImagOut(7) & fftRealOut(7) & fftImagOut(6) & fftRealOut(6);
            
            -- Falling edge of validOut triggers reading of the data from the memory
            validOutDel1 <= fftvalidOut(0);
            if fftvalidOut(0) = '0' and validOutDel1 = '1' then
                reorderRdAddr <= "000000";
                bufSelectWr <= not bufSelectWr;
                bufSelectRd <= bufSelectWr;
                rdRunning <= '1';
            elsif rdRunning = '1' then
                reorderRdAddr <= std_logic_vector(unsigned(reorderRdAddr) + 1);
                -- read address runs from 0 to 53
                if unsigned(reorderRdAddr) = 53 then
                    rdRunning <= '0';
                end if;
            end if;
            rdRunningDel1 <= rdRunning;
            rdRunningDel2 <= rdRunningDel1;
            bufSelectRdDel1 <= bufSelectRd;
            bufSelectRdDel2 <= bufSelectRdDel1;
        end if;
    end process;
    
    reorderWrAddrFull <= bufSelectWr & reorderWrAddr;
    reorderRdAddrFull <= bufSelectRd & reorderRdAddr;
    
    reorderRam_inst : xpm_memory_sdpram
    generic map (
        ADDR_WIDTH_A => 7,               -- DECIMAL
        ADDR_WIDTH_B => 7,               -- DECIMAL
        AUTO_SLEEP_TIME => 0,            -- DECIMAL
        BYTE_WRITE_WIDTH_A => 256,       -- DECIMAL
        CASCADE_HEIGHT => 0,             -- DECIMAL
        CLOCKING_MODE => "common_clock", -- String
        ECC_MODE => "no_ecc",            -- String
        MEMORY_INIT_FILE => "none",      -- String
        MEMORY_INIT_PARAM => "0",        -- String
        MEMORY_OPTIMIZATION => "true",   -- String
        MEMORY_PRIMITIVE => "distributed", -- String
        MEMORY_SIZE => 32768,            -- DECIMAL : 128 x 256 = 32768
        MESSAGE_CONTROL => 0,            -- DECIMAL
        READ_DATA_WIDTH_B => 256,        -- DECIMAL
        READ_LATENCY_B => 2,             -- DECIMAL
        READ_RESET_VALUE_B => "0",       -- String
        RST_MODE_A => "SYNC",            -- String
        RST_MODE_B => "SYNC",            -- String
        SIM_ASSERT_CHK => 0,             -- DECIMAL; 0=disable simulation messages, 1=enable simulation messages
        USE_EMBEDDED_CONSTRAINT => 0,    -- DECIMAL
        USE_MEM_INIT => 0,               -- DECIMAL
        USE_MEM_INIT_MMI => 0,           -- DECIMAL
        WAKEUP_TIME => "disable_sleep",  -- String
        WRITE_DATA_WIDTH_A => 256,       -- DECIMAL
        WRITE_MODE_B => "read_first",    -- String
        WRITE_PROTECT => 0               -- DECIMAL  -- if '1', adds a lut to gate the wr enable based on ena/enb (I think)
    ) port map (
        dbiterrb => open,        -- 1-bit output: Status signal to indicate double bit error occurrence on the data output of port B.
        doutb => reorderDout,    -- READ_DATA_WIDTH_B-bit output: Data output for port B read operations.
        sbiterrb => open,        -- 1-bit output: Status signal to indicate single bit error occurrence on the data output of port B.
        addra => reorderWrAddrFull, -- ADDR_WIDTH_A-bit input: Address for port A write operations.
        addrb => reorderRdAddrFull, -- ADDR_WIDTH_B-bit input: Address for port B read operations.
        clka => clk,           -- 1-bit input: Clock signal for port A. Also clocks port B when parameter CLOCKING_MODE is "common_clock".
        clkb => clk,           -- 1-bit input: Clock signal for port B when parameter CLOCKING_MODE is "independent_clock". 
        dina => reorderDin, -- WRITE_DATA_WIDTH_A-bit input: Data input for port A write operations.
        ena => '1',            -- 1-bit input: Memory enable signal for port A. Must be high on clock cycles when write operations are initiated. Pipelined internally.
        enb => '1',            -- 1-bit input: Memory enable signal for port B. Must be high on clock cycles when read operations are initiated. Pipelined internally.
        injectdbiterra => '0', -- 1-bit input: Controls double bit error injection on input data when ECC enabled 
        injectsbiterra => '0', -- 1-bit input: Controls single bit error injection on input data when ECC enabled 
        regceb => '1',         -- 1-bit input: Clock Enable for the last register stage on the output data path.
        rstb => '0',           -- 1-bit input: Reset signal for the final port B output register stage. 
        sleep => '0',          -- 1-bit input: sleep signal to enable the dynamic power saving feature.
        wea => reorderWE       -- WRITE_DATA_WIDTH_A/BYTE_WRITE_WIDTH_A-bit input: Write enable vector for port A input data port dina. 1 bit wide when word-wide writes are used. 
    );

    process(clk)
    begin
        if rising_edge(clk) then
            for i in 0 to 3 loop
                o_data(i).vpol.re <= reorderDout(i*64 + 15 downto i*64 + 0);  -- 16 bit data to go to the fine delay module.
                o_data(i).vpol.im <= reorderDout(i*64 + 31 downto i*64 + 16);
                o_data(i).hpol.re <= reorderDout(i*64 + 47 downto i*64 + 32);
                o_data(i).hpol.im <= reorderDout(i*64 + 63 downto i*64 + 48);
            end loop;
            o_valid <= rdRunningDel2;
        end if;
    end process;    
    
end Behavioral;
